/* DODS local netcdf calls,  Reza  */
/*
 *	Copyright 1995, University Corporation for Atmospheric Research
 *
 *  Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose without fee is hereby granted, provided
 * that the above copyright notice appear in all copies, that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of UCAR/Unidata not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  UCAR makes no
 * representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.  It is
 * provided with no support and without obligation on the part of UCAR
 * Unidata, to assist in its use, correction, modification, or enhancement.
 *
 */
/* "$Id: lnetcdf.h,v 1.2 1996/09/17 17:06:59 jimg Exp $" */

#ifndef _LNETCDF_
#define _LNETCDF_

/*
 * NB: The following feature-test line is too long in order to accomodate a 
 * bug in the VMS 5.3 C compiler.
 */
#ifndef HAVE_PROTOTYPES
#   if defined(__STDC__) || defined(__GNUC__) || defined(__cplusplus) || defined(c_plusplus)
#       define	HAVE_PROTOTYPES
#   endif
#endif

#undef PROTO
#ifdef HAVE_PROTOTYPES 
#   define	PROTO(x)	x
#else
#   define	PROTO(x)	()
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern int lnccreate	PROTO((
    const char*	path,
    int		cmode
));
extern int lncopen	PROTO((
    const char*	path,
    int		mode
));
extern int lncredef	PROTO((
    int		ncid
));
extern int lncendef	PROTO((
    int		ncid
));
extern int lncclose	PROTO((
    int		ncid
));
extern int lncinquire	PROTO((
    int		ncid,
    int*	ndims,
    int*	nvars,
    int*	natts, 
    int*	recdim
));
extern int lncsync	PROTO((
    int		ncid
));
extern int lncabort	PROTO((
    int		ncid
));
extern int lncdimdef	PROTO((
    int		ncid,
    const char*	name,
    long	length
));
extern int lncdimid	PROTO((
    int		ncid,
    const char*	name
));
extern int lncdiminq	PROTO((
    int		ncid,
    int		dimid,
    char*	name,
    long*	length
));
extern int lncdimrename	PROTO((
    int		ncid,
    int		dimid,
    const char*	name
));
extern int lncvardef	PROTO((
    int		ncid,
    const char*	name,
    nc_type	datatype, 
    int		ndims,
    const int*	dim
));
extern int lncvarid	PROTO((
    int		ncid,
    const char*	name
));

extern int lncvarcpy  PROTO((
    int        incdf, 
    int        varid, 
    int        outcdf
));

extern int lncvarinq	PROTO((
    int		ncid,
    int		varid,
    char*	name,
    nc_type*	datatype,
    int*	ndims,
    int*	dim,
    int*	natts
));
extern int lncvarput1	PROTO((
    int		ncid,
    int		varid,
    const long*	coords,
    const void*	value
));
extern int lncvarget1	PROTO((
    int		ncid,
    int		varid,
    const long*	coords,
    void*	value
));
extern int lncvarput	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count, 
    const void*	value
));
extern int lncvarget	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count, 
    void*	value
));
extern int lncvarputs	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count,
    const long*	stride,
    const void*	values
));
extern int lncvargets	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count,
    const long*	stride,
    void*	values
));
extern int lncvarputg	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count,
    const long*	stride,
    const long*	imap,
    const void* values
));
extern int lncvargetg	PROTO((
    int		ncid,
    int		varid,
    const long*	start,
    const long*	count,
    const long*	stride,
    const long*	imap,
    void*	values
));
extern int lncvarrename	PROTO((
    int		ncid,
    int		varid,
    const char*	name
));
extern int lncattput	PROTO((
    int		ncid,
    int		varid,
    const char*	name, 
    nc_type	datatype,
    int		len,
    const void*	value
));
extern int lncattinq	PROTO((
    int		ncid,
    int		varid,
    const char*	name, 
    nc_type*	datatype,
    int*	len
));
extern int lncattget	PROTO((
    int		ncid,
    int		varid,
    const char*	name, 
    void*	value
));
extern int lncattcopy	PROTO((
    int		incdf,
    int		invar,
    const char*	name, 
    int		outcdf,
    int		outvar
));
extern int lncattname	PROTO((
    int		ncid,
    int		varid,
    int		attnum,
    char*	name
));
extern int lncattrename	PROTO((
    int		ncid,
    int		varid,
    const char*	name, 
    const char*	newname
));
extern int lncattdel	PROTO((
    int		ncid,
    int		varid,
    const char*	name
));
extern int lnctypelen	PROTO((
    nc_type	datatype
));
extern int lncsetfill	PROTO((
    int		ncid,
    int		fillmode
));
extern int lncrecinq		PROTO((
    int		ncid,
    int*	nrecvars,
    int*	recvarids,
    long*	recsizes
));
extern int lncrecget		PROTO((
    int		ncid,
    long	recnum,
    void**	datap
));
extern int lncrecput		PROTO((
    int		ncid,
    long	recnum,
    void* const* datap
));

#ifdef __cplusplus
}
#endif

#endif /* _LNETCDF_ */
